import 'dart:collection';

import 'package:objd/basic/condition.dart';
import 'package:objd/basic/entity.dart';
import 'package:objd/basic/for_list.dart';
import 'package:objd/basic/score.dart';
import 'package:objd/basic/scoreboard.dart';
import 'package:objd/basic/widget.dart';
import 'package:objd/wrappers/execute.dart';

class Delay {
	static const String _scoreboardName = 'dabric_delay';
	static final HashMap<int, Score> _tickers = HashMap();

	static Widget load() {
		return For.of([
			Scoreboard(_scoreboardName, addIntoLoad: false),
			..._tickers.values.map((v) => v.set(0))
		]);
	}

	static Widget tick() {
		List<Widget> actions = [];

		_tickers.forEach((k, v) {
			actions.addAll([
				Execute(If: Condition.score(v.matchesRange(Range(from: k))), children: [v.set(0)]),
				v.add(1)
			]);
		});

		return For.of([
			...actions
		]);
	}

	static void _addDelay(int ticks) {
		if (_tickers.containsKey(ticks)) { return; }
		_tickers[ticks] = Score(Entity.PlayerName('d_${ticks}'), _scoreboardName, addNew: false);
	}

	static Condition then(int ticks) {
		_addDelay(ticks);
		return Condition.score(_tickers[ticks].matchesRange(Range(from: ticks)));
	}
}
